Index: trunk/sources/HeuristicLab.Permutation/3.3/Tests/OrderCrossoverTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/Tests/OrderCrossoverTest.cs	(revision 2852)
+++ trunk/sources/HeuristicLab.Permutation/3.3/Tests/OrderCrossoverTest.cs	(revision 2854)
@@ -1,3 +1,24 @@
-﻿using HeuristicLab.Permutation;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Permutation;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 using HeuristicLab.Core;
@@ -68,89 +89,13 @@
     public void OrderCrossoverCrossTest() {
       TestRandom random = new TestRandom();
-      Permutation parent1, parent2, expected, actual;
-      ItemArray<Permutation> parents;
-      OrderCrossover_Accessor target = new OrderCrossover_Accessor(new PrivateObject(typeof(OrderCrossover)));
-      // The following test is based on an example from Eiben, A.E. and Smith, J.E. 2003. Introduction to Evolutionary Computation. Natural Computing Series, Springer-Verlag Berlin Heidelberg, pp. 55-56
-      random.Reset();
-      random.IntNumbers = new int[] { 3, 6 };
-      parent1 = new Permutation(new int[] { 0, 1, 2, 3, 4, 5, 6, 7, 8 });
-      Assert.IsTrue(parent1.Validate());
-      parent2 = new Permutation(new int[] { 8, 2, 6, 7, 1, 5, 4, 0, 3 });
-      Assert.IsTrue(parent2.Validate());
-      parents = new ItemArray<Permutation>(new Permutation[] { parent1, parent2 });
-      expected = new Permutation(new int[] { 2, 7, 1, 3, 4, 5, 6, 0, 8 });
-      Assert.IsTrue(expected.Validate());
-      actual = target.Cross(random, parents);
-      Assert.IsTrue(actual.Validate());
-      Assert.IsTrue(Auxiliary.PermutationIsEqualByPosition(expected, actual));
-      // The following test is based on an example from Larranaga, P. et al. 1999. Genetic Algorithms for the Travelling Salesman Problem: A Review of Representations and Operators. Artificial Intelligence Review, 13, pp. 129-170.
-      random.Reset();
-      random.IntNumbers = new int[] { 2, 4 };
-      parent1 = new Permutation(new int[] { 0, 1, 2, 3, 4, 5, 6, 7 });
-      Assert.IsTrue(parent1.Validate());
-      parent2 = new Permutation(new int[] { 1, 3, 5, 7, 6, 4, 2, 0 });
-      Assert.IsTrue(parent2.Validate());
-      parents = new ItemArray<Permutation>(new Permutation[] { parent1, parent2 });
-      expected = new Permutation(new int[] { 7, 6, 2, 3, 4, 0, 1, 5 });
-      actual = target.Cross(random, parents);
-      Assert.IsTrue(actual.Validate());
-      Assert.IsTrue(Auxiliary.PermutationIsEqualByPosition(expected, actual));
-      // The following test is based on an example from Talbi, E.G. 2009. Metaheuristics - From Design to Implementation. Wiley, p. 218.
-      random.Reset();
-      random.IntNumbers = new int[] { 2, 5 };
-      parent1 = new Permutation(new int[] { 0, 1, 2, 3, 4, 5, 6, 7, 8 });
-      Assert.IsTrue(parent1.Validate());
-      parent2 = new Permutation(new int[] { 7, 3, 0, 4, 8, 2, 5, 1, 6 });
-      Assert.IsTrue(parent2.Validate());
-      parents = new ItemArray<Permutation>(new Permutation[] { parent1, parent2 });
-      expected = new Permutation(new int[] { 0, 8, 2, 3, 4, 5, 1, 6, 7 });
-      Assert.IsTrue(expected.Validate());
-      actual = target.Cross(random, parents);
-      Assert.IsTrue(actual.Validate());
-      Assert.IsTrue(Auxiliary.PermutationIsEqualByPosition(expected, actual));
-      // The following test is not based on published examples
-      random.Reset();
-      random.IntNumbers = new int[] { 0, 5 };
-      parent1 = new Permutation(new int[] { 2, 1, 4, 3, 7, 8, 6, 0, 5, 9 });
-      Assert.IsTrue(parent1.Validate());
-      parent2 = new Permutation(new int[] { 5, 3, 4, 0, 9, 8, 2, 7, 1, 6 });
-      Assert.IsTrue(parent2.Validate());
-      parents = new ItemArray<Permutation>(new Permutation[] { parent1, parent2 });
-      expected = new Permutation(new int[] { 2, 1, 4, 3, 7, 8, 6, 5, 0, 9 });
-      Assert.IsTrue(expected.Validate());
-      actual = target.Cross(random, parents);
-      Assert.IsTrue(actual.Validate());
-      Assert.IsTrue(Auxiliary.PermutationIsEqualByPosition(expected, actual));
-      // based on the previous with changed breakpoints
-      random.Reset();
-      random.IntNumbers = new int[] { 6, 9 };
-      expected = new Permutation(new int[] { 3, 4, 8, 2, 7, 1, 6, 0, 5, 9 });
-      Assert.IsTrue(expected.Validate());
-      actual = target.Cross(random, parents);
-      Assert.IsTrue(actual.Validate());
-      Assert.IsTrue(Auxiliary.PermutationIsEqualByPosition(expected, actual));
-      // another one based on the previous with changed breakpoints
-      random.Reset();
-      random.IntNumbers = new int[] { 0, 9 };
-      expected = new Permutation(new int[] { 2, 1, 4, 3, 7, 8, 6, 0, 5, 9 });
-      Assert.IsTrue(expected.Validate());
-      actual = target.Cross(random, parents);
-      Assert.IsTrue(actual.Validate());
-      Assert.IsTrue(Auxiliary.PermutationIsEqualByPosition(expected, actual));
+      OrderCrossover_Accessor target = 
+        new OrderCrossover_Accessor(new PrivateObject(typeof(OrderCrossover)));
       // perform a test with more than two parents
       random.Reset();
       bool exceptionFired = false;
       try {
-        target.Cross(random, new ItemArray<Permutation>(new Permutation[] { new Permutation(4), new Permutation(4), new Permutation(4)}));
+        target.Cross(random, new ItemArray<Permutation>(new Permutation[] { 
+          new Permutation(4), new Permutation(4), new Permutation(4)}));
       } catch (System.InvalidOperationException) {
-        exceptionFired = true;
-      }
-      Assert.IsTrue(exceptionFired);
-      // perform a test when two permutations are of unequal length
-      random.Reset();
-      exceptionFired = false;
-      try {
-        target.Cross(random, new ItemArray<Permutation>(new Permutation[] { new Permutation(8), new Permutation(6) }));
-      } catch (System.ArgumentException) {
         exceptionFired = true;
       }
Index: trunk/sources/HeuristicLab.Permutation/3.3/Tests/PartiallyMatchedCrossoverTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/Tests/PartiallyMatchedCrossoverTest.cs	(revision 2854)
+++ trunk/sources/HeuristicLab.Permutation/3.3/Tests/PartiallyMatchedCrossoverTest.cs	(revision 2854)
@@ -0,0 +1,145 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Permutation;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Permutation.Tests {
+
+
+  /// <summary>
+  ///This is a test class for PartiallyMatchedCrossover and is intended
+  ///to contain all PartiallyMatchedCrossover Unit Tests
+  ///</summary>
+  [TestClass()]
+  public class PartiallyMatchedCrossoverTest {
+
+
+    private TestContext testContextInstance;
+
+    /// <summary>
+    ///Gets or sets the test context which provides
+    ///information about and functionality for the current test run.
+    ///</summary>
+    public TestContext TestContext {
+      get {
+        return testContextInstance;
+      }
+      set {
+        testContextInstance = value;
+      }
+    }
+
+    #region Additional test attributes
+    // 
+    //You can use the following additional attributes as you write your tests:
+    //
+    //Use ClassInitialize to run code before running the first test in the class
+    //[ClassInitialize()]
+    //public static void MyClassInitialize(TestContext testContext)
+    //{
+    //}
+    //
+    //Use ClassCleanup to run code after all tests in a class have run
+    //[ClassCleanup()]
+    //public static void MyClassCleanup()
+    //{
+    //}
+    //
+    //Use TestInitialize to run code before running each test
+    //[TestInitialize()]
+    //public void MyTestInitialize()
+    //{
+    //}
+    //
+    //Use TestCleanup to run code after each test has run
+    //[TestCleanup()]
+    //public void MyTestCleanup()
+    //{
+    //}
+    //
+    #endregion
+
+
+    /// <summary>
+    ///A test for Cross
+    ///</summary>
+    [TestMethod()]
+    [DeploymentItem("HeuristicLab.Permutation-3.3.dll")]
+    public void PartiallyMatchedCrossTest() {
+      TestRandom random = new TestRandom();
+      PartiallyMatchedCrossover_Accessor target =
+        new PartiallyMatchedCrossover_Accessor(new PrivateObject(typeof(PartiallyMatchedCrossover)));
+      // perform a test with more than two parents
+      random.Reset();
+      bool exceptionFired = false;
+      try {
+        target.Cross(random, new ItemArray<Permutation>(new Permutation[] { 
+          new Permutation(4), new Permutation(4), new Permutation(4)}));
+      }
+      catch (System.InvalidOperationException) {
+        exceptionFired = true;
+      }
+      Assert.IsTrue(exceptionFired);
+    }
+
+    /// <summary>
+    ///A test for Apply
+    ///</summary>
+    [TestMethod()]
+    public void PartiallyMatchedCrossoverApplyTest() {
+      TestRandom random = new TestRandom();
+      Permutation parent1, parent2, expected, actual;
+      // The following test is based on an example from Larranaga, 1999. Genetic Algorithms for the Traveling Salesman Problem.
+      random.Reset();
+      random.IntNumbers = new int[] { 3, 5 };
+      parent1 = new Permutation(new int[] { 0, 1, 2, 3, 4, 5, 6, 7 });
+      Assert.IsTrue(parent1.Validate());
+      parent2 = new Permutation(new int[] { 2, 6, 4, 0, 5, 7, 1, 3 });
+      Assert.IsTrue(parent2.Validate());
+      expected = new Permutation(new int[] { 2, 6, 7, 3, 4, 5, 1, 0 });
+      Assert.IsTrue(expected.Validate());
+      actual = PartiallyMatchedCrossover.Apply(random, parent1, parent2);
+      Assert.IsTrue(actual.Validate());
+      Assert.IsTrue(Auxiliary.PermutationIsEqualByPosition(expected, actual));
+     
+      // perform a test when the two permutations are of unequal length
+      random.Reset();
+      bool exceptionFired = false;
+      try {
+        PartiallyMatchedCrossover.Apply(random, new Permutation(8), new Permutation(6));
+      }
+      catch (System.ArgumentException) {
+        exceptionFired = true;
+      }
+      Assert.IsTrue(exceptionFired);
+    }
+
+    /// <summary>
+    ///A test for PartiallyMatchedCrossover Constructor
+    ///</summary>
+    [TestMethod()]
+    public void PartiallyMatchedCrossoverConstructorTest() {
+      PartiallyMatchedCrossover target = new PartiallyMatchedCrossover();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Permutation/3.3/Tests/PositionBasedCrossoverTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/Tests/PositionBasedCrossoverTest.cs	(revision 2854)
+++ trunk/sources/HeuristicLab.Permutation/3.3/Tests/PositionBasedCrossoverTest.cs	(revision 2854)
@@ -0,0 +1,147 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Permutation;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Permutation.Tests {
+  /// <summary>
+  ///This is a test class for PositionBasedCrossover and is intended
+  ///to contain all PositionBasedCrossover Unit Tests
+  ///</summary>
+  [TestClass()]
+  public class PositionBasedCrossoverTest {
+
+
+    private TestContext testContextInstance;
+
+    /// <summary>
+    ///Gets or sets the test context which provides
+    ///information about and functionality for the current test run.
+    ///</summary>
+    public TestContext TestContext {
+      get {
+        return testContextInstance;
+      }
+      set {
+        testContextInstance = value;
+      }
+    }
+
+    #region Additional test attributes
+    // 
+    //You can use the following additional attributes as you write your tests:
+    //
+    //Use ClassInitialize to run code before running the first test in the class
+    //[ClassInitialize()]
+    //public static void MyClassInitialize(TestContext testContext)
+    //{
+    //}
+    //
+    //Use ClassCleanup to run code after all tests in a class have run
+    //[ClassCleanup()]
+    //public static void MyClassCleanup()
+    //{
+    //}
+    //
+    //Use TestInitialize to run code before running each test
+    //[TestInitialize()]
+    //public void MyTestInitialize()
+    //{
+    //}
+    //
+    //Use TestCleanup to run code after each test has run
+    //[TestCleanup()]
+    //public void MyTestCleanup()
+    //{
+    //}
+    //
+    #endregion
+
+
+    /// <summary>
+    ///A test for Cross
+    ///</summary>
+    [TestMethod()]
+    [DeploymentItem("HeuristicLab.Permutation-3.3.dll")]
+    public void PositionBasedCrossoverCrossTest() {
+      TestRandom random = new TestRandom();
+      PositionBasedCrossover_Accessor target = new PositionBasedCrossover_Accessor(
+        new PrivateObject(typeof(PositionBasedCrossover)));
+     
+      // perform a test with more than two parents
+      random.Reset();
+      bool exceptionFired = false;
+      try {
+        target.Cross(random, new ItemArray<Permutation>(new Permutation[] {
+          new Permutation(4), new Permutation(4), new Permutation(4) }));
+      }
+      catch (System.InvalidOperationException) {
+        exceptionFired = true;
+      }
+      Assert.IsTrue(exceptionFired);
+    }
+
+    /// <summary>
+    ///A test for Apply
+    ///</summary>
+    [TestMethod()]
+    [DeploymentItem("HeuristicLab.Permutation-3.3.dll")]
+    public void PositionBasedCrossoverApplyTest() {
+      TestRandom random = new TestRandom();
+      Permutation parent1, parent2, expected, actual;
+
+      // The following test is based on an example from Larranaga, 1999. Genetic Algorithms for the Traveling Salesman Problem.
+      random.Reset();
+      random.IntNumbers = new int[] { 3, 1, 2, 5 };
+      parent1 = new Permutation(new int[] { 0, 1, 2, 3, 4, 5, 6, 7 });
+      Assert.IsTrue(parent1.Validate());
+      parent2 = new Permutation(new int[] { 1, 3, 5, 7, 6, 4, 2, 0 });
+      Assert.IsTrue(parent2.Validate());
+
+      expected = new Permutation(new int[] { 0, 3, 5, 1, 2, 4, 6, 7 });
+      Assert.IsTrue(expected.Validate());
+      actual = PositionBasedCrossover.Apply(random, parent1, parent2);
+      Assert.IsTrue(actual.Validate());
+      Assert.IsTrue(Auxiliary.PermutationIsEqualByPosition(expected, actual));
+
+      // perform a test when two permutations are of unequal length
+      random.Reset();
+      bool exceptionFired = false;
+      try {
+        PositionBasedCrossover.Apply(random, new Permutation(8), new Permutation(6));
+      }
+      catch (System.ArgumentException) {
+        exceptionFired = true;
+      }
+      Assert.IsTrue(exceptionFired);
+    }
+
+    /// <summary>
+    ///A test for PositionBasedCrossover Constructor
+    ///</summary>
+    [TestMethod()]
+    public void PositionBasedCrossoverConstructorTest() {
+      PositionBasedCrossover target = new PositionBasedCrossover();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Permutation/3.3/Tests/Random.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/Tests/Random.cs	(revision 2852)
+++ trunk/sources/HeuristicLab.Permutation/3.3/Tests/Random.cs	(revision 2854)
@@ -1,3 +1,24 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using System.Collections.Generic;
 using System.Linq;
Index: trunk/sources/HeuristicLab.Permutation/3.3/Tests/ScrambleManipulatorTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/Tests/ScrambleManipulatorTest.cs	(revision 2854)
+++ trunk/sources/HeuristicLab.Permutation/3.3/Tests/ScrambleManipulatorTest.cs	(revision 2854)
@@ -0,0 +1,122 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Permutation;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Permutation.Tests {
+
+
+  /// <summary>
+  ///This is a test class for ScrambleManipulator and is intended
+  ///to contain all ScrambleManipulator Unit Tests
+  ///</summary>
+  [TestClass()]
+  public class ScrambleManipulatorTest {
+
+
+    private TestContext testContextInstance;
+
+    /// <summary>
+    ///Gets or sets the test context which provides
+    ///information about and functionality for the current test run.
+    ///</summary>
+    public TestContext TestContext {
+      get {
+        return testContextInstance;
+      }
+      set {
+        testContextInstance = value;
+      }
+    }
+
+    #region Additional test attributes
+    // 
+    //You can use the following additional attributes as you write your tests:
+    //
+    //Use ClassInitialize to run code before running the first test in the class
+    //[ClassInitialize()]
+    //public static void MyClassInitialize(TestContext testContext)
+    //{
+    //}
+    //
+    //Use ClassCleanup to run code after all tests in a class have run
+    //[ClassCleanup()]
+    //public static void MyClassCleanup()
+    //{
+    //}
+    //
+    //Use TestInitialize to run code before running each test
+    //[TestInitialize()]
+    //public void MyTestInitialize()
+    //{
+    //}
+    //
+    //Use TestCleanup to run code after each test has run
+    //[TestCleanup()]
+    //public void MyTestCleanup()
+    //{
+    //}
+    //
+    #endregion
+
+
+    /// <summary>
+    ///A test for Apply
+    ///</summary>
+    [TestMethod()]
+    public void ScrambleManipulatorApplyTest() {
+      TestRandom random = new TestRandom();
+      Permutation parent, expected;
+      // The following test is based on an example from Larranaga, P. et al. 1999. Genetic Algorithms for the Travelling Salesman Problem: A Review of Representations and Operators. Artificial Intelligence Review, 13
+      random.Reset();
+      random.IntNumbers = new int[] { 3, 6, 1, 1, 1, 0 };
+      parent = new Permutation(new int[] { 0, 1, 2, 3, 4, 5, 6, 7 });
+      Assert.IsTrue(parent.Validate());
+      
+      expected = new Permutation(new int[] { 0, 1, 2, 4, 5, 6, 3, 7 });
+      Assert.IsTrue(expected.Validate());
+      ScrambleManipulator.Apply(random, parent);
+      Assert.IsTrue(parent.Validate());
+      Assert.IsTrue(Auxiliary.PermutationIsEqualByPosition(expected, parent));
+     
+      // perform a test when the two permutations are of unequal length
+      random.Reset();
+      bool exceptionFired = false;
+      try {
+        CyclicCrossover.Apply(random, new Permutation(8), new Permutation(6));
+      }
+      catch (System.ArgumentException) {
+        exceptionFired = true;
+      }
+      Assert.IsTrue(exceptionFired);
+    }
+
+    /// <summary>
+    ///A test for ScrambleManipulator Constructor
+    ///</summary>
+    [TestMethod()]
+    public void ScrambleManipulatorConstructorTest() {
+      ScrambleManipulator target = new ScrambleManipulator();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Permutation/3.3/Tests/Swap2ManipulatorTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/Tests/Swap2ManipulatorTest.cs	(revision 2854)
+++ trunk/sources/HeuristicLab.Permutation/3.3/Tests/Swap2ManipulatorTest.cs	(revision 2854)
@@ -0,0 +1,122 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Permutation;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Permutation.Tests {
+
+
+  /// <summary>
+  ///This is a test class for Swap2Manipulator and is intended
+  ///to contain all Swap2Manipulator Unit Tests
+  ///</summary>
+  [TestClass()]
+  public class Swap2ManipulatorTest {
+
+
+    private TestContext testContextInstance;
+
+    /// <summary>
+    ///Gets or sets the test context which provides
+    ///information about and functionality for the current test run.
+    ///</summary>
+    public TestContext TestContext {
+      get {
+        return testContextInstance;
+      }
+      set {
+        testContextInstance = value;
+      }
+    }
+
+    #region Additional test attributes
+    // 
+    //You can use the following additional attributes as you write your tests:
+    //
+    //Use ClassInitialize to run code before running the first test in the class
+    //[ClassInitialize()]
+    //public static void MyClassInitialize(TestContext testContext)
+    //{
+    //}
+    //
+    //Use ClassCleanup to run code after all tests in a class have run
+    //[ClassCleanup()]
+    //public static void MyClassCleanup()
+    //{
+    //}
+    //
+    //Use TestInitialize to run code before running each test
+    //[TestInitialize()]
+    //public void MyTestInitialize()
+    //{
+    //}
+    //
+    //Use TestCleanup to run code after each test has run
+    //[TestCleanup()]
+    //public void MyTestCleanup()
+    //{
+    //}
+    //
+    #endregion
+
+
+    /// <summary>
+    ///A test for Apply
+    ///</summary>
+    [TestMethod()]
+    public void Swap2ManipulatorApplyTest() {
+      TestRandom random = new TestRandom();
+      Permutation parent, expected;
+      // The following test is based on an example from Eiben, A.E. and Smith, J.E. 2003. Introduction to Evolutionary Computation. Natural Computing Series, Springer-Verlag Berlin Heidelberg, p. 45
+      random.Reset();
+      random.IntNumbers = new int[] { 1, 4 };
+      parent = new Permutation(new int[] { 0, 1, 2, 3, 4, 5, 6, 7, 8 });
+      Assert.IsTrue(parent.Validate());
+
+      expected = new Permutation(new int[] { 0, 4, 2, 3, 1, 5, 6, 7, 8 });
+      Assert.IsTrue(expected.Validate());
+      Swap2Manipulator.Apply(random, parent);
+      Assert.IsTrue(parent.Validate());
+      Assert.IsTrue(Auxiliary.PermutationIsEqualByPosition(expected, parent));
+     
+      // perform a test when the two permutations are of unequal length
+      random.Reset();
+      bool exceptionFired = false;
+      try {
+        CyclicCrossover.Apply(random, new Permutation(8), new Permutation(6));
+      }
+      catch (System.ArgumentException) {
+        exceptionFired = true;
+      }
+      Assert.IsTrue(exceptionFired);
+    }
+
+    /// <summary>
+    ///A test for Swap2Manipulator Constructor
+    ///</summary>
+    [TestMethod()]
+    public void Swap2ManipulatorConstructorTest() {
+      Swap2Manipulator target = new Swap2Manipulator();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Permutation/3.3/Tests/Swap3ManipulatorTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/Tests/Swap3ManipulatorTest.cs	(revision 2854)
+++ trunk/sources/HeuristicLab.Permutation/3.3/Tests/Swap3ManipulatorTest.cs	(revision 2854)
@@ -0,0 +1,123 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Permutation;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Permutation.Tests {
+
+
+  /// <summary>
+  ///This is a test class for Swap3Manipulator and is intended
+  ///to contain all Swap3Manipulator Unit Tests
+  ///</summary>
+  [TestClass()]
+  public class Swap3ManipulatorTest {
+
+
+    private TestContext testContextInstance;
+
+    /// <summary>
+    ///Gets or sets the test context which provides
+    ///information about and functionality for the current test run.
+    ///</summary>
+    public TestContext TestContext {
+      get {
+        return testContextInstance;
+      }
+      set {
+        testContextInstance = value;
+      }
+    }
+
+    #region Additional test attributes
+    // 
+    //You can use the following additional attributes as you write your tests:
+    //
+    //Use ClassInitialize to run code before running the first test in the class
+    //[ClassInitialize()]
+    //public static void MyClassInitialize(TestContext testContext)
+    //{
+    //}
+    //
+    //Use ClassCleanup to run code after all tests in a class have run
+    //[ClassCleanup()]
+    //public static void MyClassCleanup()
+    //{
+    //}
+    //
+    //Use TestInitialize to run code before running each test
+    //[TestInitialize()]
+    //public void MyTestInitialize()
+    //{
+    //}
+    //
+    //Use TestCleanup to run code after each test has run
+    //[TestCleanup()]
+    //public void MyTestCleanup()
+    //{
+    //}
+    //
+    #endregion
+
+
+    /// <summary>
+    ///A test for Apply
+    ///</summary>
+    [TestMethod()]
+    public void Swap3ManipulatorApplyTest() {
+      TestRandom random = new TestRandom();
+      Permutation parent, expected;
+      // Test manipulator
+      random.Reset();
+      random.IntNumbers = new int[] { 1, 3, 6 };
+      random.DoubleNumbers = new double[] { 0 };
+      parent = new Permutation(new int[] { 0, 1, 2, 3, 4, 5, 6, 7, 8 });
+      Assert.IsTrue(parent.Validate());
+
+      expected = new Permutation(new int[] { 0, 3, 2, 6, 4, 5, 1, 7, 8 });
+      Assert.IsTrue(expected.Validate());
+      Swap3Manipulator.Apply(random, parent);
+      Assert.IsTrue(parent.Validate());
+      Assert.IsTrue(Auxiliary.PermutationIsEqualByPosition(expected, parent));
+     
+      // perform a test when the two permutations are of unequal length
+      random.Reset();
+      bool exceptionFired = false;
+      try {
+        CyclicCrossover.Apply(random, new Permutation(8), new Permutation(6));
+      }
+      catch (System.ArgumentException) {
+        exceptionFired = true;
+      }
+      Assert.IsTrue(exceptionFired);
+    }
+
+    /// <summary>
+    ///A test for Swap3Manipulator Constructor
+    ///</summary>
+    [TestMethod()]
+    public void Swap3ManipulatorConstructorTest() {
+      Swap3Manipulator target = new Swap3Manipulator();
+    }
+  }
+}
